## ttyd-1.3.2+git-f60398.tar.xz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
cmake_policy(SET CMP0048 NEW)

project(ttyd VERSION "1.3.2")

if(CMAKE_VERSION VERSION_LESS "3.1")
    if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
    else()
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
    endif()
else()
    set(CMAKE_C_STANDARD 99)
endif()

set(LIBWEBSOCKETS_MIN_VERSION 1.7.0)
set(SOURCE_FILES src/server.c src/http.c src/protocol.c src/utils.c)

find_package(OpenSSL REQUIRED)
find_package(Libwebsockets ${LIBWEBSOCKETS_MIN_VERSION} QUIET)

find_package(PkgConfig)

if(Libwebsockets_FOUND)
    set(LIBWEBSOCKETS_INCLUDE_DIR ${LIBWEBSOCKETS_INCLUDE_DIR} ${LIBWEBSOCKETS_INCLUDE_DIRS})
else() # try to find libwebsockets with pkg-config
    pkg_check_modules(Libwebsockets REQUIRED libwebsockets>=${LIBWEBSOCKETS_MIN_VERSION})
    find_path(LIBWEBSOCKETS_INCLUDE_DIR libwebsockets.h
            HINTS ${LIBWEBSOCKETS_INCLUDEDIR} ${LIBWEBSOCKETS_INCLUDE_DIRS})
    find_library(LIBWEBSOCKETS_LIBRARIES NAMES websockets libwebsockets
            HINTS ${LIBWEBSOCKETS_LIBDIR} ${LIBWEBSOCKETS_LIBRARY_DIRS})
    include(FindPackageHandleStandardArgs)
    find_package_handle_standard_args(LIBWEBSOCKETS DEFAULT_MSG LIBWEBSOCKETS_LIBRARIES LIBWEBSOCKETS_INCLUDE_DIR)
    mark_as_advanced(LIBWEBSOCKETS_INCLUDE_DIR LIBWEBSOCKETS_LIBRARIES)
endif()

include(CheckIncludeFile)
check_include_file(lws_config.h HAVE_LWS_CONFIG_H)

pkg_check_modules(PC_JSON-C REQUIRED json-c)
find_path(JSON-C_INCLUDE_DIR json.h
        HINTS ${PC_JSON-C_INCLUDEDIR} ${PC_JSON-C_INCLUDE_DIRS} PATH_SUFFIXES json-c json)
find_library(JSON-C_LIBRARY NAMES json-c libjson-c
        HINTS ${PC_JSON-C_LIBDIR} ${PC_JSON-C_LIBRARY_DIRS})
include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(JSON-C DEFAULT_MSG JSON-C_LIBRARY JSON-C_INCLUDE_DIR)
mark_as_advanced(JSON-C_INCLUDE_DIR JSON-C_LIBRARY)

find_program(CMAKE_XXD NAMES xxd)
add_custom_command(OUTPUT html.h
        COMMAND ${CMAKE_XXD} -i index.html html.h
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
        COMMENT "Generating html.h from index.html")
list(APPEND SOURCE_FILES html.h)

set(INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR} ${LIBWEBSOCKETS_INCLUDE_DIR} ${JSON-C_INCLUDE_DIR})
set(LINK_LIBS util pthread ${OPENSSL_LIBRARIES} ${LIBWEBSOCKETS_LIBRARIES} ${JSON-C_LIBRARY})

if(WIN32)
    list(APPEND LINK_LIBS shell32)
endif()

add_executable(${PROJECT_NAME} ${SOURCE_FILES})
target_include_directories(${PROJECT_NAME} PUBLIC ${INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${LINK_LIBS})
target_compile_definitions(${PROJECT_NAME} PRIVATE TTYD_VERSION="${PROJECT_VERSION}")

include(GNUInstallDirs)

install(TARGETS ${PROJECT_NAME} DESTINATION "${CMAKE_INSTALL_BINDIR}" COMPONENT prog)
install(FILES man/ttyd.1 DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" COMPONENT doc)

set(CPACK_PACKAGE_NAME "${PROJECT_NAME}")
set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${PROJECT_NAME} - Share your terminal over the web")
set(CPACK_PACKAGE_CONTACT "Shuanglei Tao <tsl0922@gmail.com>")
set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}_${CMAKE_SYSTEM_PROCESSOR}")

set(CPACK_GENERATOR "DEB")
SET(CPACK_DEBIAN_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
set(CPACK_DEBIAN_PACKAGE_SECTION "shells")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://tsl0922.github.io/ttyd")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libjson-c2, libwebsockets7, libssl1.0.0, libc6 (>= 2.14)")

include(CPack)

=== openwrt/Makefile ===
#
# Copyright (C) 2016 Shuanglei Tao <tsl0922@gmail.com>
#
# This is free software, licensed under the GNU General Public License v2.
# See /LICENSE for more information.
#

include $(TOPDIR)/rules.mk

PKG_NAME:=ttyd
PKG_VERSION:=1.3.2
PKG_RELEASE:=1

PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
PKG_SOURCE_PROTO:=git
PKG_SOURCE_SUBDIR:=$(PKG_NAME)-$(PKG_VERSION)
PKG_SOURCE_URL:=https://github.com/tsl0922/ttyd.git
PKG_SOURCE_VERSION:=$(PKG_VERSION)

PKG_LICENSE:=MIT
PKG_LICENSE_FILES:=LICENSE

CMAKE_INSTALL:=1

include $(INCLUDE_DIR)/package.mk
include $(INCLUDE_DIR)/cmake.mk

define Package/ttyd
	SECTION:=utils
	CATEGORY:=Utilities
	TITLE:=Command-line tool for sharing terminal over the web
	DEPENDS:=+libopenssl +libjson-c +libpthread +libwebsockets-openssl
	URL:=https://github.com/tsl0922/ttyd
	SUBMENU:=Terminal
	MAINTAINER:=Shuanglei Tao <tsl0922@gmail.com>
endef

define Package/ttyd/description
ttyd is a command-line tool for sharing terminal over the web.
endef

define Package/ttyd/install
	$(INSTALL_DIR) $(1)/usr/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/ttyd $(1)/usr/bin/
endef

$(eval $(call BuildPackage,ttyd))

=== debian/changelog ===
ttyd (1.3.1-1) unstable; urgency=medium

  * Initial release.

 -- Boyuan Yang <073plan@gmail.com>  Thu, 30 Mar 2017 12:10:50 +0800

=== debian/control ===
Source: ttyd
Section: utils
Priority: optional
Maintainer: Boyuan Yang <073plan@gmail.com>
Build-Depends:
 debhelper (>= 9),
 cmake,
 pkg-config,
 libwebsockets-dev,
 libjson-c-dev,
 libssl-dev,
 xxd | vim-common,
Standards-Version: 3.9.8
Homepage: https://tsl0922.github.io/ttyd/
Vcs-Git: https://github.com/tsl0922/ttyd.git
Vcs-Browser: https://github.com/tsl0922/ttyd.git

Package: ttyd
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Web terminal sharing tool
 Ttyd is a simple command-line tool for sharing terminal over the web, inspired
 by GoTTY.
 .
 Features include:
  * Built on top of Libwebsockets with C for speed
  * Fully-featured terminal based on Xterm.js with CJK and IME support
  * SSL support based on OpenSSL
  * Run any custom command with options
  * Basic authentication support and many other custom options
  * Cross platform: macOS, Linux, FreeBSD, OpenWrt/LEDE, Windows

=== msys2/json-c/PKGBUILD ===
# Maintainer: Shuanglei Tao <tsl0922@gmail.com>

pkgname=json-c
pkgver=0.12.1
pkgrel=1
pkgdesc="A JSON implementation in C"
arch=('i686' 'x86_64')
url="https://github.com/json-c/json-c"
license=('MIT')
makedepends=('gcc' 'make' 'autoconf')
source=("https://s3.amazonaws.com/json-c_releases/releases/${pkgname}-${pkgver}.tar.gz")
sha256sums=('2a136451a7932d80b7d197b10441e26e39428d67b1443ec43bbba824705e1123')

build() {
  cd ${srcdir}/${pkgname}-${pkgver}
  ./configure \
    --prefix=/usr \
    --enable-shared \
    --enable-static
  make
}

package() {
  options=('staticlibs')
  cd ${srcdir}/${pkgname}-${pkgver}
  make DESTDIR="$pkgdir" install
}

=== msys2/libwebsockets/PKGBUILD ===
# Maintainer: Shuanglei Tao <tsl0922@gmail.com>

pkgname="libwebsockets"
pkgver=2.1.0
pkgrel=1
pkgdesc="A lightweight pure C library for websockets (msys)"
arch=('i686' 'x86_64')
url="http://libwebsockets.org"
license=('LGPL 2.1')
makedepends=('gcc' 'cmake' 'zlib-devel' 'openssl-devel')
source=(${pkgname}-${pkgver}.tar.gz::"https://github.com/warmcat/${pkgname}/archive/v${pkgver}.tar.gz")
sha256sums=('bcc96aaa609daae4d3f7ab1ee480126709ef4f6a8bf9c85de40aae48e38cce66')

prepare() {
  cd "${srcdir}/${pkgname}-${pkgver}"
}

build() {
  mkdir -p "${srcdir}/build-${CARCH}"
  cd "${srcdir}/build-${CARCH}"

  cmake \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DLWS_USE_BUNDLED_ZLIB=OFF \
    -DLWS_WITHOUT_TESTAPPS=ON \
    -DCMAKE_BUILD_TYPE=Release \
    ../${pkgname}-${pkgver}

  make
}

package() {
  depends=('zlib-devel' 'openssl-devel')
  options=('staticlibs')
  cd "${srcdir}/build-${CARCH}"
  make DESTDIR=${pkgdir} install
}

=== msys2/ttyd/PKGBUILD ===
# Maintainer: Shuanglei Tao <tsl0922@gmail.com>

pkgname="ttyd"
pkgver=1.3.2
pkgrel=1
pkgdesc="A command-line tool for sharing terminal over the web"
arch=('i686' 'x86_64')
url="https://github.com/tsl0922/ttyd"
license=('MIT')
makedepends=('gcc' 'cmake' 'json-c' 'libwebsockets' 'vim')
source=(${pkgname}-${pkgver}.tar.gz::"https://github.com/tsl0922/${pkgname}/archive/${pkgver}.tar.gz")
sha256sums=('6e85335c11df68e6401178269920a586bce7e66045bd0b225f6d2bc58356d105')

prepare() {
  cd "${srcdir}/${pkgname}-${pkgver}"
}

build() {
  mkdir -p "${srcdir}/build-${CARCH}"
  cd "${srcdir}/build-${CARCH}"

  cmake \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_BUILD_TYPE=Release \
    ../${pkgname}-${pkgver}

  make
}

package() {
  options=('staticlibs' 'strip')
  cd "${srcdir}/build-${CARCH}"
  make DESTDIR=${pkgdir} install
}

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# main packaging script based on dh7 syntax
%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ttyd-$1.tar.gz%" \
 https://github.com/tsl0922/ttyd/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
